###############################################################################
# WAP.pl                                                                  #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.3.2                                      #
# Released:       December 2001; Updated August 17, 2004                      #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
# =========================================================================== #
# Mod Name:    WRPAT 0.2 for YaBB  Gold - SP1.3.1-1.3.2                       #
# Written by:  JannoL - webmaster@jannol.com                                  #
###############################################################################

$WAPplmodver = "0.2 for 1 Gold - SP 1.3.1-1.3.2";

sub WAP_RecentPosts {
	# Content-type
	print "Content-type: text/vnd.wap.wml\n\n";
	
	my $display = 5;
	my( @memset, @categories, %data, %cat, $numfound, $oldestfound, $curcat, %catname, %cataccess, %catboards, $openmemgr, @membergroups, %openmemgr, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $mtime, $counter, $board, $notify );
	
	@categories = ();
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

	$oldestfound = stringtotime("01/10/37 $txt{'107'} 00:00:00");

	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			fopen(FILE, "$boardsdir/$curboard.txt");
			@threads = <FILE>;
			fclose(FILE);

			fopen(FILE, "$boardsdir/$curboard.dat");
			@boardinfo = <FILE>;
			fclose(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			for ($i = 0; $i < @threads; $i++) {
				chomp $threads[$i];
				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				fopen(FILE, "$datadir/$tnum.txt") || next;
				while( <FILE> ) { $message = $_; }
				# get only the last post for this thread.
				fclose(FILE);

				chomp $message;
				if( $message ) {
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
					$mtime = stringtotime($mdate);
					if( $numfound >= $display && $mtime <= $oldestfound ) {
						next;
					}
					else {
						$data{$mtime} = [$curboard, $tnum, $treplies, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate];
						if( $mtime < $oldestfound ) { $oldestfound = $mtime; }
						++$numfound;
					}
				}
			}
		}
	}
	
	@messages = sort {$b <=> $a } keys %data;
	if( @messages ) {
		if( @messages > $display ) { $#messages = $display - 1; }
		$counter = 1;
		# Load Censor List
		&LoadCensorList;
	}
	else {
		print qq~$txt{'170'}~;
	}
	
	# Begin WML Page Top
	print qq~
	<?xml version="1.0"?><!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.3//EN" "http://www.wapforum.org/DTD/wml13.dtd"><wml>
	<head>
	<meta forua="true" http-equiv="Cache-Control" content="no-cache"/>
	</head>
	<card id="recent" title="$mbname $waptxt{'2'}">
	<p>[$display $txt{'214'}]<br />
	~;
	# End WML Page Top
	
	for( $i = 0; $i < @messages; $i++ ) {
		($board, $tnum, $c, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $tstate) = @{ $data{$messages[$i]} };
		$displayname = $mname;
		if( $tusername ne 'Guest' ) {
			&LoadUser($tusername);
			$tname = exists $userprofile{$tusername} ? $userprofile{$tusername}->[1] : $tname;
			$tname ||= $txt{'470'};
		}
		if( $musername ne 'Guest' ) {
			&LoadUser($musername);
			$mname = exists $userprofile{$musername} ? $userprofile{$musername}->[1] : $mname;
			$mname ||= $txt{'470'};
		}
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		
		# Begin WML Page Body
		&FromHTML($catname{$cat{$board}});
		&FromHTML($boardinfo{$board});		
 		&FromHTML($msub);
 		&FromHTML($tname);
 		&FromHTML($mname);
 		
		# Use my WAP YaBBC that I included as a sub (WAP_DoUBBC)
		&wrap;
		&WAP_DoUBBC;
		&wrap2;

 		&ToHTML($catname{$cat{$board}});
		&ToHTML($boardinfo{$board});		
 		&ToHTML($msub);
 		&ToHTML($tname);
 		&ToHTML($mname);
 		
 		#$board = chr($board);
 		$tnum = int($tnum);
 		#print qq~<i>$txt{'109'}: $tname</i><br />~;
		
 		$message =~ s~<br>~<br />~gi;
 		
 		# Now print the Recent Posts as WML
		print qq~
		<small>
		<b>$counter&nbsp; $catname{$cat{$board}} / $boardinfo{$board}->[0]</b><br />
		<i>$txt{'22'} $txt{'525'}: $mname<br />$mdate</i><br />
		<a href="$scripturl?board=$board&amp;action=wapgotorecentpost&amp;num=$tnum">$msub</a> ($c)<br />
		------------------------------<br />
		$message<br />
		------------------------------<br /><br />
		</small>~;
	# End WML Page Body
			++$counter;
	}
	
	# Begin WML Page Bottom
		print qq~
		<small>$yycopyright</small>
		</p>
		</card></wml>
		~;
	# End WML Page Bottom
	exit;
}

sub WAP_GotoRecentPost {
	# Content-type
	print "Content-type: text/vnd.wap.wml\n\n";
	
	my $viewnum = $INFO{'num'};
	if( $viewnum =~ /\D/ ) { &wap_fatal_error($txt{'337'}); }
	if( $currentboard eq '' ) { &wap_fatal_error($txt{'1'}); }
	$maxmessagedisplay = int(27500 / $MaxMessLen);
	my($buffer,$views,$lastposter,$moderators,$counter,$counterwords,$pageindex,$msubthread,$mnum,$mstate,$mdate,$msub,$mname,$memail,$mreplies,$musername,$micon,$noposting,$threadclass,$notify,$max,$start,$bgcolornum,$windowbg,$mattach,$mip,$mlm,$mlmb,$lastmodified,$postinfo,$star,$sendm,$topicdate);
	my(@userprofile,@messages);

	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &wap_fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$curcat = <FILE>;
	fclose(FILE);
	#$curcat = $cat;
	fopen(FILE, "$boardsdir/$curcat.cat") || &wap_fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	chomp $cat; # fix
	fclose(FILE);

	# Add 1 to the number of views of this thread.
	if(fopen(FILE, "$datadir/$viewnum.data")) {
		$tmpa = <FILE>;
		fclose(FILE);
	}
	elsif( -e "$datadir/$viewnum.data" ) { &wap_fatal_error("102 $txt{'106'}: $txt{'23'} $viewnum.data"); }
	else { $tmpa = '0'; }
	($tmpa, $tmpb) = split( /\|/, $tmpa );
	$tmpa++;
	fopen(FILE, "+>$datadir/$viewnum.data") || &wap_fatal_error("103 $txt{'106'}: $txt{'23'} $viewnum.data");
	print FILE qq~$tmpa|$tmpb~;
	fclose(FILE);
	$views = $tmpa - 1;
	
	# Check to make sure this thread isn't locked.
	($mnum,$msubthread,$mname,$memail,$mdate,$mreplies,$musername,$micon,$mstate) = split( /\|/, $yyThreadLine );
	$noposting = $viewnum eq $mnum && $mstate == 1 ? 1 : 0;

	&LoadCensorList;	# Load Censor List

	# Build the page links list.
	#if ($INFO{'showall'} eq "true") { $maxmessagedisplay = $mreplies + 1; }
	$postdisplaynum = 3;	# max number of pages to display
	$max = $mreplies + 1;
	$start = $INFO{'start'} || 0;
	$start = $start > $mreplies ? $mreplies : $start;
	$start = ( int( $start / $maxmessagedisplay ) ) * $maxmessagedisplay;
	$tmpa = 1;
	$tmpx = int( $max / $maxmessagedisplay );
	if ($start >= (($postdisplaynum-1) * $maxmessagedisplay)) { $startpage = $start - (($postdisplaynum-1) * $maxmessagedisplay); $tmpa = int( $startpage / $maxmessagedisplay ) + 1; }
	if ($max >= $start + ($postdisplaynum * $maxmessagedisplay)) { $endpage = $start + ($postdisplaynum * $maxmessagedisplay); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi&amp;action=wapgotorecentpost&amp;num=$viewnum&amp;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $maxmessagedisplay) { $pageindex = qq~<a href="$cgi&amp;action=wapgotorecentpost&amp;num=$viewnum&amp;start=0">1</a>~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $maxmessagedisplay ) {
		$pageindex .= $start == $counter ? qq~&nbsp;$tmpa ~ : qq~ <a href="$cgi&amp;action=wapgotorecentpost&amp;num=$viewnum&amp;start=$counter">$tmpa</a>~;		
		$tmpa++;
	}
	$tmpx = $max - $maxmessagedisplay;
	$outerpn = int($tmpx / $maxmessagedisplay) + 0;
	$lastpn = int($mreplies / $maxmessagedisplay) + 1;
	$lastptn = ($lastpn - 1) * $maxmessagedisplay;
	if ($endpage < $max - ($maxmessagedisplay) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~ <a href="$cgi&amp;action=wapgotorecentpost&amp;num=$viewnum&amp;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

	# Look for a poll file for this thread. If excists, Just view the comments of it and refer user to the web for viewing the poll
	if (-e "$datadir/$viewnum.poll") { $has_poll = 1; } else { $has_poll = 0; }
	if ($has_poll) { $mpoll = qq~$polltxt{'15'}\: ~; $pollinfo = qq~<i>$waptxt{'3'}</i><br />~; }

	if(!$MenuType) { $sm = 1; }
	$counter = 0;

	fopen(FILE,"$datadir/$viewnum.txt") || &wap_fatal_error("104 $txt{'106'}: $txt{'23'} $viewnum.txt");

	# Skip past the posts in this thread until we reach $start.
	while($counter < $start && ($buffer = <FILE>)) { $counter++; }
	
	$#messages = $maxmessagedisplay - 1;
	for($counter = 0; $counter < $maxmessagedisplay && ($buffer = <FILE>); $counter++) {
		$messages[$counter] = $buffer;
	}
	fclose(FILE);
	$#messages = $counter - 1;
	$counter = $start;
	
	# Begin WML Page Top	
	print qq~
	<?xml version="1.0"?><!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.3//EN" "http://www.wapforum.org/DTD/wml13.dtd"><wml>
	<head>
	<meta forua="true" http-equiv="Cache-Control" content="no-cache" />
	</head>
	<card id="post" title="$msubthread">
	<p><a href="$scripturl?action=waprecentposts">$txt{'193'} $txt{'324'} $txt{'214'}</a><br />
	[$txt{'139'}: $pageindex]<br />
	~;
	# End WML Page Top
	
	# For each post in this thread:
	foreach (@messages) {
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $_);
		# Should we show "last modified by?"
		if( $mlm && $showmodify && $mlm ne "" && $mlmb ne "") {
			$mlm = &timeformat($mlm);
			&LoadUser($mlmb);
			$mlmb = $userprofile{$mlmb}->[1] || $mlmb || $txt{'470'};
			$lastmodified = qq~&#171; <i>$txt{'211'}: $mlm $txt{'525'} $mlmb</i> &#187;~;
		}
		else {
			$mlm = '-';
			$lastmodified = '';
		}
		$msub ||= $txt{'24'};
		$messdate = &timeformat($mdate);

		# If the user isn't a guest, load his/her info.
		if($musername ne 'Guest' && ! $yyUDLoaded{$musername} && -e("$memberdir/$musername.dat") ) {
			&LoadUserDisplay($musername);	# If user is not in memory, s/he must be loaded.
		}
		if($yyUDLoaded{$musername}) {
			@userprofile = @{$userprofile{$musername}};
			$displayname = $userprofile[1];
#			$memberinfo = $memberinfo{$musername};
#			$memberinfo =~ s~\n~~g;
			$postinfo = qq~($txt{'26'}: $userprofile[6])~;
#			$memail = $userprofile[2];
		}
		else {
			$musername = "Guest";
			$memberinfo = "($txt{'28'})";
			$postinfo = $memberinfo;
			@userprofile = ();
			$displayname = $mname;
		}
		# Censor the subject and message.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		# Begin WML Page Body
 		# I really don't know why but for some reason I had to send the code to the sub FromHTML first or it occasionally failed
 		&FromHTML($msub);
		&FromHTML($postinfo);
 		&FromHTML($displayname);
 		&FromHTML($lastmodified);

 		# Put 'Started' text before the date of the first post
 		if($counter != 0) { $counterwords = "$txt{'146'} #$counter -"; }
 		else { $counterwords = "$waptxt{'1'} -"; }
 		
 		# Put the message back into the proper variable to do wap_ubbc on it
 		$message = $postmessage;
		# Use the WAP YaBBC converter that I included as a sub (WAP_DoUBBC) in this file.
		&wrap;
 		&WAP_DoUBBC;
 		&wrap2;

	 	# Send to sub ToHTML incase there are illegal characters for WML output
  	&ToHTML($msub);
  	&ToHTML($postinfo);
  	&ToHTML($displayname);
  	
  	$message =~ s~<br>~<br />~gi;
		
 		# Now print the Posts as WML
		print qq~
		<small>
		<b>$txt{'319'} - $mpoll$msub</b><br />
		$pollinfo
		<i>$counterwords $messdate</i><br />
		<i>$displayname $postinfo</i><br />
   	------------------------------<br />
   	$message<br />
   	$lastmodified<br />
   	------------------------------<br /><br />
   	</small>
		~;
		# End WML Page Body
	
		$counter++;
	}
	
		# Begin WML Page Bottom
		print qq~
		<small>$yycopyright</small>
		</p>
		</card></wml>
		~;
		# End WML Page Bottom
		exit;
}

sub WAP_DoUBBC {
	# This is not the efficient method but my thought was to think of complements for use with WML, as e.g. Image converter,
	# or maybe use some kind of indicators as *glowing red* but for the moment most of the YaBBC is simply cleared
	$message =~ s~\[b\](.+?)\[/b\]~<b>$1</b>~isg;
	$message =~ s~\[i\](.+?)\[/i\]~<i>$1</i>~isg;
	$message =~ s~\[u\](.+?)\[/u\]~<u>$1</u>~isg;
	$message =~ s~\[s\](.+?)\[/s\]~<s>$1</s>~isg;
#	$message =~ s~\[glow=(\w+?),(\d+),(\d+)\](.+?)\[/glow\]~$4~isg;
#	$message =~ s~\[shadow=(\w+?),(\D\S+?),(\d+)\](.+?)\[/shadow\]~$4~isg;
#	$message =~ s~\[move\](.+?)\[/move\]~$1~isg;
	$message =~ s~\[pre\](.+?)\[/pre\]~'<pre>' . dopre($1) . '</pre>'~iseg;
	$message =~ s~\[left\](.+?)\[/left\]~<p align="left">$1</p>~isg;
	$message =~ s~\[center\](.+?)\[/center\]~<p align="center">$1</p>~isg;
	$message =~ s~\[right\](.+?)\[/right\]~<p align="right">$1</p>~isg;
	$message =~ s~\[hr\]\s~------------------------------~g;
	$message =~ s~\[hr\]~------------------------------<br />~g;
	$message =~ s~\[size=(.+?)\](.+?)\[/size\]~<big>$2</big>~isg;
	$message =~ s~\[font=(.+?)\](.+?)\[/font\]~$2~isg;
	$message =~ s~\[color=(.+?)\](.+?)\[/color\]~$2~isg;
	$message =~ s~\[flash\=(\S+?),(\S+?)](\S+?)\[\/flash\]~<img src="$imagesdir/wbmp/flash.wbmp" alt="$waptxt{'4'}"/><br />&#187; $waptxt{'5'}\: $3 &#171;~g;
# 	$message =~ s~\[url\]\s*www\.(\S+?)\s*\[/url\]~www.$1~isg;
# 	$message =~ s~\[url=\s*(\S\w+\://\S+?)\s*\](.+?)\[/url\]~$1 $2~isg;
# 	$message =~ s~\[url=\s*(\S+?)\](.+?)\s*\[/url\]~$1 $2~isg;
# 	$message =~ s~\[url\]\s*(\S+?)\s*\[/url\]~$1~isg;

	$message =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~<img src="$imagesdir/wbmp/img.wbmp" alt="$waptxt{'6'}"/><br />&#187; $waptxt{'7'}\: $1$2 &#171;~isg;
	
	$message =~ s~\[code\]\n*(.+?)\n*\[\/code\]~\[Code: $1\]~ig;
	$message =~ s~\[quote\]\n*(.+?)\n*\[/quote\]~\[Quote: $1\]~isg;
	#$message =~ s~<br>~<br />~gi;
	$message =~ s~\[\*\]~<br />&#187;~isg;
	$message =~ s~\/me\s+(.*)~<font color="#FF0000"><i>* $displayname $1</i></font>~ig;
	$message =~ s/\&amp\;/\&/gi; # The & character has caused me as much gray hairs as a bankruptcy would do...
	$yycopyright =~ s~<a.*>.*($mbname).*</a>~$1 $waptxt{'2'}~i;
	$yycopyright =~ s~<a href="http://(.*)".*>.*YaBB.*</a>~$waptxt{'8'} $1~i;
	$yycopyright =~ s/\<\/?[^>]*\>//gi;
	$yycopyright =~ s~($waptxt{'8'})(.*com)~<br />$1<br />$2<br />~i;
}

sub wap_fatal_error {
	my $e = $_[0];
	&ToHTML($e);
	# Allows the following WML-tags in error messages: <br /> <b>
	$e =~ s/&lt;(\/?)br&gt;/<$1br\/>/ig;
	$e =~ s/&lt;(\/?)b&gt;/<$1b>/ig;
	
	print qq~
	<?xml version="1.0"?><!DOCTYPE wml PUBLIC "-//WAPFORUM//DTD WML 1.3//EN" "http://www.wapforum.org/DTD/wml13.dtd"><wml>
	<head>
	<meta forua="true" http-equiv="Cache-Control" content="no-cache"/>
	</head>
	<card id="error" title="$txt{'106'}">
	<p>$txt{'106'}<br />
	$e<br />
	<a href="$scripturl?action=waprecentposts">$txt{'193'} $txt{'324'} $txt{'214'}</a>
	</p>
	</card>
	</wml>
	~;
	exit;
}

1;